#pragma once

namespace a8
{
    class XObject;
    class MutableXObject;
}

namespace f8
{

    struct JsonHttpRequest
    {
        bool pending = false;
        unsigned long saddr = 0;
        int socket_handle = 0;
        time_t create_time = 0;
        time_t handle_time = 0;
        std::string query_str;
        std::shared_ptr<a8::XObject> params;
        std::shared_ptr<a8::MutableXObject> resp_xobj;

        int async_pending_count = 0;
        void* context = nullptr;
        void (*free_context)(void*) = nullptr;

        JsonHttpRequest();
        ~JsonHttpRequest();
        std::string Response();
    };

}
